import wx
import os.path

app = wx.App(False)

frm = wx.Frame(None, wx.ID_ANY, 'DumbAPGui')
frm.SetSizeHints(200, 100)

dlg = wx.Dialog(frm, title='Settings')

boxF = wx.StaticBoxSizer(wx.VERTICAL, frm, '')
boxS = wx.StaticBoxSizer(wx.VERTICAL, dlg, 'Settings')
boxP = wx.StaticBoxSizer(wx.VERTICAL, frm, 'Progress')

boxs = wx.BoxSizer(wx.VERTICAL)

lbl = wx.StaticText(frm, label='Select file:')
btns = wx.Button(frm, label='Settings ...')
btn = wx.Button(frm, label='Process file')
boxlf = wx.BoxSizer()
txtfn = wx.TextCtrl(frm, style=wx.TE_READONLY, value='No file selected')
boxlf.Add(txtfn, 5, wx.EXPAND)
opnbtn = wx.Button(frm, label='Select...')
boxlf.Add(opnbtn, 1, wx.EXPAND)
btn.Disable()
boxF.Add(lbl, 0, wx.EXPAND)
boxF.Add(boxlf, 0, wx.EXPAND)
boxF.Add(btns, 0, wx.EXPAND)
boxF.AddSpacer(3)
boxF.Add(btn, 0, wx.EXPAND)

pb_tr = wx.Gauge(frm)
pb_ap = wx.Gauge(frm)

boxP.Add(pb_tr, 0, wx.EXPAND)
boxP.Add(pb_ap, 0, wx.EXPAND)

log = wx.TextCtrl(frm, style=wx.TE_MULTILINE|wx.TE_READONLY)

boxP.Add(log, 3, wx.EXPAND)

boxs.Add(boxF, 0, wx.EXPAND)
boxs.Add(boxP, 1, wx.EXPAND)

frm.SetSizer(boxs)
frm.Show()

dlgs = wx.BoxSizer(wx.VERTICAL)
dlgs.Add(boxS, 1, wx.EXPAND)
dlgbtns = wx.BoxSizer()
dlgok = wx.Button(dlg, wx.ID_OK, label='OK')
dlgabrt = wx.Button(dlg, wx.ID_CANCEL, label='Cancel')
dlgrst = wx.Button(dlg, label='Reset to default')
dlgbtns.Add(dlgabrt, 0, wx.EXPAND)
dlgbtns.AddSpacer(3)
dlgbtns.Add(dlgrst, 0, wx.EXPAND)
dlgbtns.AddStretchSpacer()
dlgbtns.Add(dlgok, 0, wx.EXPAND)
dlgs.Add(dlgbtns, 0, wx.EXPAND)
dlg.SetSizer(dlgs)

def show_settings(e):
    dlg.ShowModal()

frm.Bind(wx.EVT_BUTTON, show_settings, btns)

def pr_callback(cur_tr:int, traces:int, cur_ap:int, aps:int):
    pb_tr.SetRange(traces)
    pb_tr.SetValue(cur_tr+1)
    pb_ap.SetRange(aps)
    pb_ap.SetValue(cur_ap+1)
    app.Yield()

def err_callback(*args, **kwargs):
    print(*args, file=log, **kwargs)
    #log.SetPosition(log.GetLastPosition())
    app.Yield()

def select_file(e):
    odlg = wx.FileDialog(None, 'Choose AP file', '', '', '*.*', wx.FD_OPEN)
    if odlg.ShowModal() == wx.ID_OK:
        fn = odlg.GetFilename()
        dn = odlg.GetDirectory()
        txtfn.SetLabel(os.path.join(dn, fn))
        btn.Enable()
    else:
        txtfn.SetLabel('No file seleted')
        btn.Disable()

frm.Bind(wx.EVT_BUTTON, select_file, opnbtn)

def load_and_start(e):
    pb_tr.SetValue(0)
    pb_ap.SetValue(0)

    dn, fn = os.path.split(txtfn.GetLabel())
    btn.Disable()
    opnbtn.Disable()
    btns.Disable()
    log.WriteText('Loading file {}...\n'.format(fn))
    log.WriteText('(Output will be in {})\n'.format(dn))
    app.Yield()
    try:
        import apanalysis
        apanalysis.analyze(os.path.join(dn, fn), pr_callback, err_callback)
    except Exception as x:
        log.WriteText('ERROR: {}\n\n'.format(x))
    else:
        log.WriteText('Done! \U0001F389\n\n')
        pb_tr.SetValue(pb_tr.GetRange())
        pb_ap.SetValue(pb_ap.GetRange())
    btn.Enable()
    btns.Enable()
    opnbtn.Enable()

frm.Bind(wx.EVT_BUTTON, load_and_start, btn)

app.MainLoop()
